local bri1 = love.graphics.newImage("wolftextures.png")
local h = love.window.getHeight()
local w = love.window.getWidth()
love.mouse.setVisible(false)
love.mouse.setGrabbed(true)

local map = love.image.newImageData(20,20)
for i = 0, 19 do
	for j = 0, 19 do
		map:setPixel(i,j,love.math.random(1,4),love.math.random(1,4),0,0)
	end
end
map = love.graphics.newImage(map)

local pla = {
act_x = 16+5*32,
act_y = 16+5*32,
act_z = 16,
speed = 2,
r=0,
ry=240,
ll=false,
rr=false,
uu=false,
vu=false,
vd=false,
}


local center = w/2
local camdist = center/math.tan(math.rad(30))

local myShader = love.graphics.newShader[[
	extern number camdist;
	extern number h;
	extern number w;
	extern Image tile;
	extern number tw;
	extern number th;
	extern number plax;
	extern number play;
	extern number plaz;
	extern number plar;
	extern number plary;
	extern Image map;
	//extern number mapc[20*20];
	vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ){
		number invert1 = 0- 2*plary;
		number invert2 = 32;
		number invert3 = 0;
		number tiletexture = 5;
		bool invert4 = false;
		if (screen_coords.y < h/2-plary) {
			screen_coords.y = h-screen_coords.y;
			invert1 = 0;
			invert2 = 0;
			invert3 = 180;
			invert4 = true;
		}
		number pr2 = (screen_coords.x - w/2)*(60/w);
		number pr = (plar+180-invert3) + pr2;
		if (pr>=360) {
			pr = pr - 360;
		}
		if (pr<=0) {
			pr = 360+pr;
		}
		if (pr2>=360) {
			pr = pr - 360;
		}
		if (pr2<=0) {
			pr = 360+pr;
		}
		number y = play+cos(plar*3.14159265/180);
		number x = plax+sin(plar*3.14159265/180);
		
		number d = h/2;
		number sc = camdist*(invert2 - plaz)/(d-(screen_coords.y)+plary+invert1);
		number sc2 = sc/cos(pr2*3.14159265/180);
		number olddist = 1/cos(pr2*3.14159265/180);
		number newx = x-(olddist-sc2)*cos(pr*3.14159265/180);
		number newy = y-(olddist-sc2)*sin(pr*3.14159265/180);
		if (floor(newx/32) >=1 && floor(newx/32) <= 20 && floor(newy/32) >= 1 && floor(newy/32) <= 20) {
			number index = Texel(map,vec2(floor(newx/32-1)/20,floor(newy/32-1)/20)).g;
			if (invert4) {
				index = Texel(map,vec2(floor(newx/32-1)/20,floor(newy/32-1)/20)).r;
			}
			tiletexture = 256*index;
		}
		number d2 = floor((floor(newy/32)+1-newy/32)*tw)+tw*tiletexture;
		number d3 = floor((floor(newx/32)+1-newx/32)*th);
		vec4 pixel2 = Texel(tile,vec2(d2/(tw*6),d3/th));
		return pixel2;	
	}
]]

myShader:send("camdist",camdist)
myShader:send("h",h)
myShader:send("w",w)
myShader:send("tile",bri1)
myShader:send("tw",64)
myShader:send("th",64)
myShader:send("map",map)
--myShader:send("mapc",mapc)

function love.update(dt)
	local mx,my = love.mouse.getPosition()
	if mx > w-2 then
		love.mouse.setPosition( 1, my )
	end
	if mx < 1 then
		love.mouse.setPosition( w-2, my )
	end
	pla.r = mx/w*360
	pla.ry = my/h*480
	if pla.uu then
		pla.act_x = pla.act_x+math.cos(math.rad(pla.r))*pla.speed*32*dt
		pla.act_y = pla.act_y+math.sin(math.rad(pla.r))*pla.speed*32*dt
	end
	if pla.vu then
		pla.act_z = pla.act_z+pla.speed*dt
		if pla.act_z >= 30 then
			pla.act_z = 30
		end
	end
	if pla.vd then
		pla.act_z = pla.act_z-pla.speed*dt
		if pla.act_z <= 2 then
			pla.act_z = 2
		end
	end
	myShader:send("plax",pla.act_x)
	myShader:send("play",pla.act_y)
	myShader:send("plaz",pla.act_z)
	myShader:send("plar",pla.r)
	myShader:send("plary",pla.ry-240)
end

function love.draw()
	love.graphics.setShader(myShader)
	love.graphics.rectangle("fill",0,0,w,h)
	love.graphics.setShader()
end

function love.keypressed(key)
	if key == " " then
    		pla.vu = true
		
	elseif key == "lshift" then
    		pla.vd = true
	elseif key == "w" then
    		pla.uu = true
	elseif key == "escape" then
		love.event.quit()
	end
end

function love.keyreleased(key)
	if key == " " then
    		pla.vu = false
	elseif key == "lshift" then
    		pla.vd = false
	elseif key == "w" then
    		pla.uu = false	
	end
end